Crazy Eddies GUI System: CEGUI::Editbox Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# CEGUI::Editbox Class Reference

Base class for an Editbox widget. More...

Inheritance diagram for CEGUI::Editbox:

[legend]
Collaboration diagram for CEGUI::Editbox:

[legend]
List of all members.

## Public Member Functions
bool | hasInputFocus (void) const
| return true if the Editbox has input focus.
bool | isReadOnly (void) const
| return true if the Editbox is read-only.
bool | isTextMasked (void) const
| return true if the text for the Editbox will be rendered masked.
bool | isTextValid (void) const
| return true if the Editbox text is valid given the currently set validation string.
const String & | getValidationString (void) const
| return the currently set validation string
size_t | getCaratIndex (void) const
| return the current position of the carat.
size_t | getSelectionStartIndex (void) const
| return the current selection start point.
size_t | getSelectionEndIndex (void) const
| return the current selection end point.
size_t | getSelectionLength (void) const
| return the length of the current selection (in code points / characters).
utf32 | getMaskCodePoint (void) const
| return the utf32 code point used when rendering masked text.
size_t | getMaxTextLength (void) const
| return the maximum text length set for this Editbox.
colour | getNormalTextColour (void) const
| return the currently set colour to be used for rendering Editbox text in the normal, unselected state.
colour | getSelectedTextColour (void) const
| return the currently set colour to be used for rendering the Editbox text when within the selected region.
colour | getNormalSelectBrushColour (void) const
| return the currently set colour to be used for rendering the Editbox selection highlight when the Editbox is active.
colour | getInactiveSelectBrushColour (void) const
| return the currently set colour to be used for rendering the Editbox selection highlight when the Editbox is inactive.
void | setReadOnly (bool setting)
| Specify whether the Editbox is read-only.
void | setTextMasked (bool setting)
| Specify whether the text for the Editbox will be rendered masked.
void | setValidationString (const String &validation_string)
| Set the text validation string.
void | setCaratIndex (size_t carat_pos)
| Set the current position of the carat.
void | setSelection (size_t start_pos, size_t end_pos)
| Define the current selection for the Editbox.
void | setMaskCodePoint (utf32 code_point)
| set the utf32 code point used when rendering masked text.
void | setMaxTextLength (size_t max_len)
| set the maximum text length for this Editbox.
void | setNormalTextColour (const colour &col)
| Set the colour to be used for rendering Editbox text in the normal, unselected state.
void | setSelectedTextColour (const colour &col)
| Set the colour to be used for rendering the Editbox text when within the selected region.
void | setNormalSelectBrushColour (const colour &col)
| Set the colour to be used for rendering the Editbox selection highlight when the Editbox is active.
void | setInactiveSelectBrushColour (const colour &col)
| Set the colour to be used for rendering the Editbox selection highlight when the Editbox is inactive.
| Editbox (const String &type, const String &name)
| Constructor for Editbox class.
virtual | ~Editbox (void)
| Destructor for Editbox class.
## Static Public Attributes
static const String | EventNamespace
| Namespace for global events.
static const argb_t | DefaultNormalTextColour = 0xFFFFFFFF
| Colour applied to normal unselected text.
static const argb_t | DefaultSelectedTextColour = 0xFF000000
| Colour applied to selected text.
static const argb_t | DefaultNormalSelectionColour = 0xFF6060FF
| Colour applied to normal selection brush.
static const argb_t | DefaultInactiveSelectionColour = 0xFF808080
| Colour applied to selection brush when widget is inactive.
static const String | EventReadOnlyModeChanged
| The read-only mode for the edit box has been changed.
static const String | EventMaskedRenderingModeChanged
| The masked rendering mode (password mode) has been changed.
static const String | EventMaskCodePointChanged
| The code point (character) to use for masked text has been changed.
static const String | EventValidationStringChanged
| The validation string has been changed.
static const String | EventMaximumTextLengthChanged
| The maximum allowable string length has been changed.
static const String | EventTextInvalidated
| Some operation has made the current text invalid with regards to the validation string.
static const String | EventInvalidEntryAttempted
| The user attempted to modify the text in a way that would have made it invalid.
static const String | EventCaratMoved
| The text carat (insert point) has changed.
static const String | EventTextSelectionChanged
| The current text selection has changed.
static const String | EventEditboxFull
| The number of characters in the edit box has reached the current maximum.
static const String | EventTextAccepted
| The user has accepted the current text by pressing Return, Enter, or Tab.
## Protected Member Functions
void | addEditboxEvents (void)
| Add edit box specific events.
virtual size_t | getTextIndexFromPosition (const Point &pt) const =0
| Return the text code point index that is rendered closest to screen position pt.
void | clearSelection (void)
| Clear the current selection setting.
void | eraseSelectedText (bool modify_text=true)
| Erase the currently selected text.
bool | isStringValid (const String &str) const
| return true if the given string matches the validation regular expression.
void | handleBackspace (void)
| Processing for backspace key.
void | handleDelete (void)
| Processing for Delete key.
void | handleCharLeft (uint sysKeys)
| Processing to move carat one character left.
void | handleWordLeft (uint sysKeys)
| Processing to move carat one word left.
void | handleCharRight (uint sysKeys)
| Processing to move carat one character right.
void | handleWordRight (uint sysKeys)
| Processing to move carat one word right.
void | handleHome (uint sysKeys)
| Processing to move carat to the start of the text.
void | handleEnd (uint sysKeys)
| Processing to move carat to the end of the text.
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.
virtual void | onReadOnlyChanged (WindowEventArgs &e)
| Event fired internally when the read only state of the Editbox has been changed.
virtual void | onMaskedRenderingModeChanged (WindowEventArgs &e)
| Event fired internally when the masked rendering mode (password mode) has been changed.
virtual void | onMaskCodePointChanged (WindowEventArgs &e)
| Event fired internally when the code point to use for masked rendering has been changed.
virtual void | onValidationStringChanged (WindowEventArgs &e)
| Event fired internally when the validation string is changed.
virtual void | onMaximumTextLengthChanged (WindowEventArgs &e)
| Event fired internally when the maximum text length for the edit box is changed.
virtual void | onTextInvalidatedEvent (WindowEventArgs &e)
| Event fired internally when something has caused the current text to now fail validation.
virtual void | onInvalidEntryAttempted (WindowEventArgs &e)
| Event fired internally when the user attempted to make a change to the edit box that would have caused it to fail validation.
virtual void | onCaratMoved (WindowEventArgs &e)
| Event fired internally when the carat (insert point) position changes.
virtual void | onTextSelectionChanged (WindowEventArgs &e)
| Event fired internally when the current text selection changes.
virtual void | onEditboxFullEvent (WindowEventArgs &e)
| Event fired internally when the edit box text has reached the set maximum length.
virtual void | onTextAcceptedEvent (WindowEventArgs &e)
| Event fired internally when the user accepts the edit box text by pressing Return, Enter, or Tab.
virtual void | onMouseButtonDown (MouseEventArgs &e)
| Handler called when a mouse button has been depressed within this window's area.
virtual void | onMouseButtonUp (MouseEventArgs &e)
| Handler called when a mouse button has been released within this window's area.
virtual void | onMouseDoubleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been double-clicked within this window's area.
virtual void | onMouseTripleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been triple-clicked within this window's area.
virtual void | onMouseMove (MouseEventArgs &e)
| Handler called when the mouse cursor has been moved within this window's area.
virtual void | onCaptureLost (WindowEventArgs &e)
| Handler called when this window loses capture of mouse inputs.
virtual void | onCharacter (KeyEventArgs &e)
| Handler called when a character-key has been pressed while this window has input focus.
virtual void | onKeyDown (KeyEventArgs &e)
| Handler called when a key as been depressed while this window has input focus.
virtual void | onTextChanged (WindowEventArgs &e)
| Handler called when the window's text is changed.
## Protected Attributes
bool | d_readOnly
| True if the editbox is in read-only mode.
bool | d_maskText
| True if the editbox text should be rendered masked.
utf32 | d_maskCodePoint
| Code point to use when rendering masked text.
size_t | d_maxTextLen
| Maximum number of characters for this Editbox.
size_t | d_caratPos
| Position of the carat / insert-point.
size_t | d_selectionStart
| Start of selection area.
size_t | d_selectionEnd
| End of selection area.
String | d_validationString
| Copy of validation reg-ex string.
RegexValidator * | d_validator
| RegEx String used for validation of text.
bool | d_dragging
| true when a selection is being dragged.
size_t | d_dragAnchorIdx
| Selection index for drag selection anchor point.
colour | d_normalTextColour
| Text colour used normally.
colour | d_selectTextColour
| Text colour used when text is highlighted.
colour | d_selectBrushColour
| Colour to apply to the selection brush.
colour | d_inactiveSelectBrushColour
| Colour to apply to the selection brush when widget is inactive / read-only.

## Detailed Description

Base class for an Editbox widget.

## Member Function Documentation

void CEGUI::Editbox::eraseSelectedText | ( | bool | modify_text = `true` | ) | `[protected]`

  | Erase the currently selected text. Parameters:
  | modify_text | when true, the actual text will be modified. When false, everything is done except erasing the characters.

size_t CEGUI::Editbox::getCaratIndex | ( | void |  | ) | const`[inline]`

| return the current position of the carat. Returns: Index of the insert carat relative to the start of the text.

colour CEGUI::Editbox::getInactiveSelectBrushColour | ( | void |  | ) | const`[inline]`

| return the currently set colour to be used for rendering the Editbox selection highlight when the Editbox is inactive. Returns: colour value describing the ARGB colour that is currently set.

utf32 CEGUI::Editbox::getMaskCodePoint | ( | void |  | ) | const`[inline]`

| return the utf32 code point used when rendering masked text. Returns: utf32 code point value representing the Unicode code point that will be rendered instead of the Editbox text when rendering in masked mode.

size_t CEGUI::Editbox::getMaxTextLength | ( | void |  | ) | const`[inline]`

| return the maximum text length set for this Editbox. Returns: The maximum number of code points (characters) that can be entered into this Editbox. Note: Depending on the validation string set, the actual length of text that can be entered may be less than the value returned here (it will never be more).

colour CEGUI::Editbox::getNormalSelectBrushColour | ( | void |  | ) | const`[inline]`

| return the currently set colour to be used for rendering the Editbox selection highlight when the Editbox is active. Returns: colour value describing the ARGB colour that is currently set.

colour CEGUI::Editbox::getNormalTextColour | ( | void |  | ) | const`[inline]`

| return the currently set colour to be used for rendering Editbox text in the normal, unselected state. Returns: colour value describing the ARGB colour that is currently set.

colour CEGUI::Editbox::getSelectedTextColour | ( | void |  | ) | const`[inline]`

| return the currently set colour to be used for rendering the Editbox text when within the selected region. Returns: colour value describing the ARGB colour that is currently set.

size_t CEGUI::Editbox::getSelectionEndIndex | ( | void |  | ) | const

| return the current selection end point. Returns: Index of the selection end point relative to the start of the text. If no selection is defined this function returns the position of the carat.

size_t CEGUI::Editbox::getSelectionLength | ( | void |  | ) | const

| return the length of the current selection (in code points / characters). Returns: Number of code points (or characters) contained within the currently defined selection.

size_t CEGUI::Editbox::getSelectionStartIndex | ( | void |  | ) | const

| return the current selection start point. Returns: Index of the selection start point relative to the start of the text. If no selection is defined this function returns the position of the carat.

virtual size_t CEGUI::Editbox::getTextIndexFromPosition | ( | const Point & | pt | ) | const`[protected, pure virtual]`

  | Return the text code point index that is rendered closest to screen position pt. Parameters:
  | pt | Point object describing a position on the screen in pixels.
Returns: Code point index into the text that is rendered closest to screen position pt.

const String& CEGUI::Editbox::getValidationString | ( | void |  | ) | const`[inline]`

| return the currently set validation string Note: Validation is performed by means of a regular expression. If the text matches the regex, the text is said to have passed validation. If the text does not match with the regex then the text fails validation. Returns: String object containing the current validation regex data

bool CEGUI::Editbox::hasInputFocus | ( | void |  | ) | const

| return true if the Editbox has input focus. Returns: true if the Editbox has keyboard input focus, false if the Editbox does not have keyboard input focus.

bool CEGUI::Editbox::isReadOnly | ( | void |  | ) | const`[inline]`

| return true if the Editbox is read-only. Returns: true if the Editbox is read only and can't be edited by the user, false if the Editbox is not read only and may be edited by the user.

bool CEGUI::Editbox::isTextMasked | ( | void |  | ) | const`[inline]`

| return true if the text for the Editbox will be rendered masked. Returns: true if the Editbox text will be rendered masked using the currently set mask code point, false if the Editbox text will be rendered as plain text.

bool CEGUI::Editbox::isTextValid | ( | void |  | ) | const

| return true if the Editbox text is valid given the currently set validation string. Note: It is possible to programmatically set 'invalid' text for the Editbox by calling setText. This has certain implications since if invalid text is set, whatever the user types into the box will be rejected when the input is validated. Validation is performed by means of a regular expression. If the text matches the regex, the text is said to have passed validation. If the text does not match with the regex then the text fails validation. Returns: true if the current Editbox text passes validation, false if the text does not pass validation.

void CEGUI::Editbox::onCaptureLost | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window loses capture of mouse inputs. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onCharacter | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a character-key has been pressed while this window has input focus. Parameters:
  | e | KeyEventArgs object whose 'codepoint' field is set to the Unicode code point (encoded as utf32) for the character typed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated. All other fields should be considered as 'junk'.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onKeyDown | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a key as been depressed while this window has input focus. Parameters:
  | e | KeyEventArgs object whose 'scancode' field is set to the Key::Scan value representing the key that was pressed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onMouseButtonDown | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been depressed within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onMouseButtonUp | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been released within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onMouseDoubleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been double-clicked within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onMouseMove | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the mouse cursor has been moved within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onMouseTripleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been triple-clicked within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onTextChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's text is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented from CEGUI::Window.

void CEGUI::Editbox::onTextInvalidatedEvent | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

| Event fired internally when something has caused the current text to now fail validation. This can be caused by changing the validation string or setting a maximum length that causes the current text to be truncated.

void CEGUI::Editbox::setCaratIndex | ( | size_t | carat_pos | ) |

  | Set the current position of the carat. Parameters:
  | carat_pos | New index for the insert carat relative to the start of the text. If the value specified is greater than the number of characters in the Editbox, the carat is positioned at the end of the text.
Returns: Nothing.

void CEGUI::Editbox::setInactiveSelectBrushColour | ( | const colour & | col | ) |

  | Set the colour to be used for rendering the Editbox selection highlight when the Editbox is inactive. Parameters:
  | col | colour value describing the ARGB colour that is to be used.
Returns: Nothing.

void CEGUI::Editbox::setMaskCodePoint | ( | utf32 | code_point | ) |

  | set the utf32 code point used when rendering masked text. Parameters:
  | code_point | utf32 code point value representing the Unicode code point that should be rendered instead of the Editbox text when rendering in masked mode.
Returns: Nothing.

void CEGUI::Editbox::setMaxTextLength | ( | size_t | max_len | ) |

  | set the maximum text length for this Editbox. Parameters:
  | max_len | The maximum number of code points (characters) that can be entered into this Editbox.
Note: Depending on the validation string set, the actual length of text that can be entered may be less than the value set here (it will never be more). Returns: Nothing.

void CEGUI::Editbox::setNormalSelectBrushColour | ( | const colour & | col | ) |

  | Set the colour to be used for rendering the Editbox selection highlight when the Editbox is active. Parameters:
  | col | colour value describing the ARGB colour that is to be used.
Returns: Nothing.

void CEGUI::Editbox::setNormalTextColour | ( | const colour & | col | ) |

  | Set the colour to be used for rendering Editbox text in the normal, unselected state. Parameters:
  | col | colour value describing the ARGB colour that is to be used.
Returns: Nothing.

void CEGUI::Editbox::setReadOnly | ( | bool | setting | ) |

  | Specify whether the Editbox is read-only. Parameters:
  | setting | true if the Editbox is read only and can't be edited by the user, false if the Editbox is not read only and may be edited by the user.
Returns: Nothing.

void CEGUI::Editbox::setSelectedTextColour | ( | const colour & | col | ) |

| Set the colour to be used for rendering the Editbox text when within the selected region. Returns: colour value describing the ARGB colour that is currently set.

void CEGUI::Editbox::setSelection | ( | size_t | start_pos,
|  | size_t | end_pos
| ) |

  | Define the current selection for the Editbox. Parameters:
  | start_pos | Index of the starting point for the selection. If this value is greater than the number of characters in the Editbox, the selection start will be set to the end of the text.
  | end_pos | Index of the ending point for the selection. If this value is greater than the number of characters in the Editbox, the selection end will be set to the end of the text.
Returns: Nothing.

void CEGUI::Editbox::setTextMasked | ( | bool | setting | ) |

  | Specify whether the text for the Editbox will be rendered masked. Parameters:
  | setting | true if the Editbox text should be rendered masked using the currently set mask code point, false if the Editbox text should be rendered as plain text.
Returns: Nothing.

void CEGUI::Editbox::setValidationString | ( | const String & | validation_string | ) |

  | Set the text validation string. Note: Validation is performed by means of a regular expression. If the text matches the regex, the text is said to have passed validation. If the text does not match with the regex then the text fails validation. Parameters:
  | validation_string | String object containing the validation regex data to be used.
Returns: Nothing.

virtual bool CEGUI::Editbox::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

  | Return whether this window was inherited from the given class name at some point in the inheritance heirarchy. Parameters:
  | class_name | The class name that is to be checked.
Returns: true if this window was inherited from class_name. false if not. Reimplemented from CEGUI::Window.